# WARNING - Generated by {fusen} from dev/flat_full.Rmd: do not edit by hand


# Test for is_dispersionMatrixValid
test_that("is_dispersionMatrixValid returns TRUE for valid dimensions", {
  matx_dispersion <- matrix(1:6, nrow = 2, ncol = 3)
  matx_bool_replication <- matrix(TRUE, nrow = 2, ncol = 3)
  expect_true(is_dispersionMatrixValid(matx_dispersion, matx_bool_replication))
})

test_that("is_dispersionMatrixValid throws an error for invalid dimensions", {
  matx_dispersion <- matrix(1:4, nrow = 2, ncol = 2)
  matx_bool_replication <- matrix(TRUE, nrow = 2, ncol = 3)
  expect_false(is_dispersionMatrixValid(matx_dispersion, matx_bool_replication))
})

# Test for generateCountTable
test_that("generateCountTable generates count table with correct dimensions", {
  mu_ij_matx_rep <- matrix(1:6, nrow = 2, ncol = 3)
  matx_dispersion_rep <- matrix(1:6, nrow = 2, ncol = 3)
  count_table <- generateCountTable(mu_ij_matx_rep, matx_dispersion_rep)
  expect_equal(dim(count_table), c(2, 3))
})



test_that("checkFractionofZero issues a warning for high fraction of zeros/ones", {
  # Test case 1: Less than 50% zeros and ones
  counts_table_1 <- matrix(c(0, 1, 2, 0, 0, 0, 0, 1, 1), ncol = 3)
  expect_message(checkFractionOfZero(counts_table_1), "50% of the counts simulated are bellow 1. Consider reviewing your input parameters.")
  
  # Test case 2: More than 50% zeros and ones
  counts_table_2 <- matrix(c(0, 1, 0, 0, 1, 10, 100, 1, 1), ncol = 3)
  expect_null(checkFractionOfZero(counts_table_2))
  
})


# Test for replicateMatrix
test_that("replicateMatrix replicates matrix correctly", {
  matrix <- matrix(1:9, nrow = 3, ncol = 3)
  replication_matrix <- matrix(TRUE, nrow = 3, ncol = 3)
  replicated_matrix <- replicateMatrix(matrix, replication_matrix)
  expect_equal(dim(replicated_matrix), c(3, 9))
})


# Test for mock_rnaseq
#test_that("mock_rnaseq returns expected output", {
  # Set up input variables
#  list_var <- NULL
#  n_genes <- 3
#  min_replicates <- 2
#  max_replicates <- 4
#  df_inputSimulation <- data.frame(gene_id = 1:3, coef_value = c(0.5, 0.3, 0.2))
#  matx_dispersion <- matrix(1:9, nrow = 3, ncol = 3)

  # Run the function
#  expect_error(mock_rnaseq(list_var, n_genes, min_replicates, max_replicates, df_inputSimulation, 
#                           matx_dispersion))
  
  
  #list_var <- init_variable(name = "my_var", mu = c(10, 20), level = 2 )
  #n_genes <- 10
  #min_replicates <- 2
  #max_replicates <- 4
  #scaling_factor <- 1
  #df_inputSimulation <- getInput2simulation(list_var, n_genes)
  #dispersion <- getDispersionMatrix(list_var, n_genes, c(1000, 1000, 1000, 1000, 1000, 1, 1, 1, 1, 1))
  #mock_rnaseq(list_var, n_genes, min_replicates, 
  #            max_replicates, 
  #            df_inputSimulation, dispersion)
  #ERROOR
#})


# Test for generateReplicationMatrix
test_that("generateReplicationMatrix generates replication matrix correctly", {
  replication_matrix <- generateReplicationMatrix(init_variable(),min_replicates = 2, max_replicates = 4)
  expect_equal(dim(replication_matrix), c(4, 2))
})

